<?php if ( ! defined( 'ABSPATH' ) ) exit;/*Exit if accessed directly*/ ?>
<?php
/*\/*\/*\/*\/*\/*\/*\/*\/*\/*\/*\/*\/*\/*\/*\/*\/*\/*\/*\/*\/*\/*\/*\/*\/*\/*\/*\/*
*
*
*	gateway helper functions for simplifying gateway developments
*	one day we will put all of this into a separate SDK/Class perhaps (?)
*
*\/*\/*\/*\/*\/*\/*\/*\/*\/*\/*\/*\/*\/*\/*\/*\/*\/*\/*\/*\/*\/*\/*\/*\/*\/*\/*\*/

function wppizza_order_prepare($wppizza_gateway_ident, $wppizza_post_data){
	/***************************************
		ini execute class
	***************************************/
	$ORDER_EXECUTE = new WPPIZZA_ORDER_EXECUTE($wppizza_gateway_ident, $wppizza_post_data);
	/***************************************
		get cart details from session data,
		update any submitted wppizza formfields
		and pass on what we need
		update userdata session, check nonces , update initialized db (by hash), get order formatted  ect
	***************************************/
	$order_details = $ORDER_EXECUTE -> order_prepare();

return $order_details;
}
/*********************************************************
*
*	[ return order details from db INITIALIZED status() by hash - omitting overkill data - adding mapped user data, if set]
*
*********************************************************/
function wppizza_get_prepared_order($wppizza_gateway_ident){
	/***************************************
		ini execute class
	***************************************/
	$ORDER_EXECUTE = new WPPIZZA_ORDER_EXECUTE($wppizza_gateway_ident);
	$order_details = $ORDER_EXECUTE -> get_prepared_order();

return $order_details ;
}

/*********************************************************
*
*	[ do wppizza_order_prepare and wppizza_get_prepared_order in one go]
*
*********************************************************/
function wppizza_prepare_order_for_payment($wppizza_gateway_ident, $wppizza_post_data){
	/***************************************
		ini execute class
	***************************************/
	$ORDER_EXECUTE = new WPPIZZA_ORDER_EXECUTE($wppizza_gateway_ident, $wppizza_post_data);
	$order_details = $ORDER_EXECUTE -> order_prepare();
	$order_details = $ORDER_EXECUTE -> get_prepared_order();

return $order_details ;
}

/*********************************************************
*
*	[ return order details from db INPROGRESS by id or hash - omitting overkill data - adding mapped user data, if set, bypassing user_id_status]
*
*********************************************************/
function wppizza_get_processed_order($order_id = false, $gateway_reply = false, $wppizza_gateway_ident = false){
	/***************************************
		ini execute class
	***************************************/
	$ORDER_EXECUTE = new WPPIZZA_ORDER_EXECUTE($wppizza_gateway_ident);//$wppizza_gateway_ident, $wppizza_post_data, $wppizza_mapped_data
	$order_details = $ORDER_EXECUTE -> get_prepared_order($order_id, $gateway_reply, true, false);//* true to set all errors critical here as we are dealing with ipn orders processed and returned from gateway, wpuserid false as ipn will not have any

return $order_details ;
}

/*********************************************************
*
*	[ execute order (ajax), returning array with redirect url]
*
*	@order_details sanitized order details
*	@transaction_id string/int
*	@transaction_details string|array (transaction details from errors should also be here)
*	@failed bool (has transaction failed or was it successful ?)
*	@display_errors array[] = array('type' => $error_code], 'message' => $error_message); if failed, generate array of type/message
*
*	returns array()
*********************************************************/
function wppizza_order_execute($order_details, $transaction_id = null, $transaction_details, $transaction_errors = false){//$display_errors = false
	/***************************************
		ini execute class
	***************************************/
	$ORDER_EXECUTE = new WPPIZZA_ORDER_EXECUTE();
	$result = $ORDER_EXECUTE->order_execute($order_details, $transaction_id, $transaction_details, $transaction_errors);//, $display_errors

return $result;
}

/*********************************************************
*
*	[ execute order (IPN), returning simply false if error]
*
*	@order_details sanitized order details
*	@transaction_id string/int
*	@transaction_details string|array (transaction details from errors should also be here)
*	@failed bool (has transaction failed or was it successful ?)
*	@display_errors array[] = array('type' => $error_code], 'message' => $error_message); if failed, generate array of type/message
*	@db_update_vars additional columns to update
*	returns array()
*********************************************************/
function wppizza_order_execute_ipn($order_details, $transaction_id, $transaction_details, $transaction_errors, $class_name, $custom_update_columns = false, $unconfirmed = false){
	$ORDER_EXECUTE = new WPPIZZA_ORDER_EXECUTE($class_name);

	$result = $ORDER_EXECUTE->order_execute($order_details, $transaction_id, $transaction_details, $transaction_errors,  true,  false, $custom_update_columns, $unconfirmed );//first true to set as ipn, second:false to not check wp_user_id (it's ipn)

return $result;
}
/*********************************************************
*
*	[ refund an order by id]
*
*********************************************************/
function wppizza_order_refund($order_id, $transaction_details, $order_details){
	$ORDER_EXECUTE = new WPPIZZA_ORDER_EXECUTE();
	$result = $ORDER_EXECUTE->order_refund($order_id, $transaction_details, $order_details);
return $result;
}
/*********************************************************
*
*	[ cancel an order by id]
*
*********************************************************/
function wppizza_order_cancel($order_id, $transaction_details, $order_details, $transaction_id = false ){
	$ORDER_EXECUTE = new WPPIZZA_ORDER_EXECUTE();
	$result = $ORDER_EXECUTE->order_cancel($order_id, $transaction_details, $order_details, $transaction_id);
return $result;
}
/*********************************************************
*
*	[ fail an order by id]
*
*********************************************************/
function wppizza_order_failed($order_id, $transaction_details, $order_details, $transaction_id = false ){
	$ORDER_EXECUTE = new WPPIZZA_ORDER_EXECUTE();
	$result = $ORDER_EXECUTE->order_failed($order_id, $transaction_details, $order_details, $transaction_id);
return $result;
}
/*********************************************************
*
*	[ expired an order by id]
*
*********************************************************/
function wppizza_order_expired($order_id, $transaction_details, $order_details, $transaction_id = false ){
	$ORDER_EXECUTE = new WPPIZZA_ORDER_EXECUTE();
	$result = $ORDER_EXECUTE->order_expired($order_id, $transaction_details, $order_details, $transaction_id);
return $result;
}
/*********************************************************
*
*	[ update transaction details for an order by id]
*
*********************************************************/
function wppizza_order_update_transaction_details($order_id, $transaction_details, $order_details = false){
	$ORDER_EXECUTE = new WPPIZZA_ORDER_EXECUTE();
	$result = $ORDER_EXECUTE->update_transaction_details($order_id, $transaction_details, $order_details);
return $result;
}

/*********************************************************
*
*	[ set order page url for transactions, add parameters (array) failed etc if required
*	also allow for setting hash distinctly (might be useful for some gateway requirements) ]
*
*********************************************************/
function wppizza_transaction_url($parameters = false, $hash = false){
	global $wppizza_options;

	$args = array();

	if(!empty($hash)){
		$args[WPPIZZA_TRANSACTION_GET_PREFIX] = $hash;
	}else{
		$args[WPPIZZA_TRANSACTION_GET_PREFIX] = WPPIZZA() -> session -> get_order_hash();
	}
	if(!empty($parameters) && is_array($parameters)){
	foreach($parameters as $k=>$v){
		$args[$k] = $v ;
	}}
	$url = add_query_arg($args, get_permalink($wppizza_options['order_settings']['orderpage']) );
return $url;
}
/*********************************************************
*	[ set url for cancelled transactions ]
*	only transactions with "cancel" in query string will be cancelled in db
*********************************************************/
function wppizza_transaction_cancel_url(){
	global $wppizza_options;
	$args = array();
	$args[WPPIZZA_TRANSACTION_CANCEL_PREFIX] = WPPIZZA() -> session -> get_order_hash();
	$url = add_query_arg($args, get_permalink($wppizza_options['order_settings']['orderpage']) );
return $url;
}

/*********************************************************
*	[ simple order page url. no parameters ]
*
*********************************************************/
function wppizza_orderpage_url(){
	global $wppizza_options;
	$url =  get_permalink($wppizza_options['order_settings']['orderpage']);
return $url;
}

/******************************************************************
*
*	[get language wpml]
*	returns language if base==true returns only first 2 chars lowercase
*
******************************************************************/
function wppizza_get_language($base=false){
	$lang='en_US';

	$locale = get_locale();
	if($locale !=''){
		$lang = $locale;
	}

	//if(WPLANG!=''){
	//	$lang = WPLANG;
	//}
	/**wpml select of full locale**/
	if(function_exists('icl_object_id') && defined('ICL_LANGUAGE_CODE')) {
		$lang = $sitepress -> get_locale(ICL_LANGUAGE_CODE);/**get full  locale**/
	}
	/**only first 2**/
	if($base){
		$lang=strtolower(substr($lang,0,2));

	}
	return $lang;
}
/******************************************************************
*
*	[get currently selected gateway]
*
******************************************************************/
function wppizza_selected_gateway($upper = true){
	$selected_gateway = WPPIZZA() -> session -> get_selected_gateway();
	if($upper){/* uppercase default*/
		$selected_gateway = strtoupper($selected_gateway);
	}
return $selected_gateway;
}
/***************************************
*	NOT IN USE but could be used if needed
***************************************/
function wppizza_gateway_logging($tx_errors = false, $gateway_reply = false, $order_id = false, $wppizza_gateway_ident = false , $error_ident = false, $logs_path = WPPIZZA_PATH_LOGS){
	/***************************************
		ini execute class
	***************************************/
	$ORDER_EXECUTE = new WPPIZZA_ORDER_EXECUTE($wppizza_gateway_ident);
	$ORDER_EXECUTE->gateway_logging($tx_errors, $gateway_reply, $order_id, false, $error_ident, $logs_path);
}

?>